<template>
  <div>
    <div class="title-anim">
      <div :ref="'titlemask'" class="mask">
        <slide-title
          v-for="(project, index) in reversedArr"
          :ref="`title-${index}`"
          :key="project.slug"
          class="title--masked"
          :active="current == index"
          :style="{ background: `${project.textcolor}` }"
        >
          {{ project.title }}
        </slide-title>
      </div>
    </div>
    <div class="title-anim title-anim--lower">
      <div :ref="'subtitlemask'" class="mask">
        <slide-title
          v-for="(project, index) in projects"
          :key="project.slug"
          :ref="`subtitle-${index}`"
          class="title--masked subtitle"
          :active="current == index"
          :style="{ background: `${project.textcolor}` }"
        >
          {{ project.description }}
        </slide-title>
      </div>
    </div>
  </div>
</template>

<script>
// import animateScrollTo from 'animated-scroll-to'
import smoothScrollIntoView from 'smooth-scroll-into-view-if-needed'
export default {
  name: 'TitleAnimVue',
  props: {
    current: {
      type: Number,
      default: 0,
    },
    projects: {
      type: Array,
      default: null,
    },
  },
  data() {
    return {}
  },
  computed: {
    reversedArr() {
      const arr = this.projects.slice().reverse()

      return arr
    },
  },
  watch: {
    current: {
      handler(val) {
        const t = this
        const all = t.projects.length - 1
        const title = all - val
        smoothScrollIntoView(t.$refs['title-' + title][0].$el, {
          behavior: 'smooth',
          block: 'nearest',
          inline: 'nearest',
          boundary: t.$refs.titlemask,
          duration: 800,
          ease: (t) => 1 + --t * t * t * t * t,
        })
        smoothScrollIntoView(t.$refs['subtitle-' + val][0].$el, {
          behavior: 'smooth',
          block: 'start',
          boundary: t.$refs.subtitlemask,
          duration: 800,
          ease: (t) => 1 + --t * t * t * t * t,
        })
      },
      // deep: true,
    },
  },
  mounted() {
    this.$refs.titlemask.scrollTo(0, this.$refs.titlemask.scrollHeight)
  },
  methods: {},
}
</script>

<style lang="scss" scoped>
@import '~assets/scss/_mixins';
@import '~assets/scss/_vars';

.title-anim {
  width: 100vw;
}

.mask {
  @apply gap-y-3;
  position: relative;
  overflow-y: hidden;
  @include interpolate(height, $vWMin, $vWMMax, 65px, 120px);
  box-sizing: content-box;
  display: flex;
  align-items: center;
  flex-direction: column;
  justify-content: flex-start;
  &__subtitle {
    justify-content: flex-start;
    flex-direction: column;
  }
  @apply m-2;
  @screen md {
    @apply m-2;
  }
}
</style>
